<?php
//Turn on debugging level
$Vtiger_Utils_Log = true;

include_once('vtlib/Vtiger/Menu.php');
include_once('vtlib/Vtiger/Module.php');

// Create module instance and save it first
$module = new Vtiger_Module();
$module->name = 'Pets';
$module->save();

//Initialize all the tables required
$module->initTables();
/*
 * Creates teh following table:
 * vtiger_pets (petid INTEGER)
 * vtiger_petscf (petid INTEGER PRIMARY KEY)
 * vtiger_petsgrouprel (petid INTEGER PRIMARY KEY, groupname VARCHAR(100))
 */
 
 // Add the module to the Menu (entry point from UI)
 $menu = Vtiger_Menu::getInstance('Contacts');
 $menu->addModule($module);
 
 // Add the basic module block
 $block1 = new Vtiger_Block();
 $block1->label = 'LBL_PET_INFORMATION';
 $module->addBlock($block1);
 
 // Add custom block (required to support Custom Fields)
 $block2 = new Vtiger_Block();
 $block2->label = 'LBL_CUSTOM_INFORMATION';
 $module->addBlock($block2);
 
 /* Create required fields and add to the block */
 $field1 = new Vtiger_Field();
 $field1->name = 'PetsName';
 $field1->table = $module->basetable;
 $field1->column = 'pet_name';
 $field1->columntype = 'VARCHAR(255)';
 $field1->uitype = 2;
 $field1->typeofdata = 'V~M';
 $block1->addField($field1); /* Create the field and adds to block */
 
 $field2 = new Vtiger_Field();
 $field2->name = 'PetsNo';
 $field2->table = $module->basetable;
 $field2->column = 'pet_no';
 $field2->columntype = 'VARCHAR(100)';
 $field2->uitype = 4;
 $field2->typeofdata = 'V~M';
 $block1->addField($field2); /* Create the field and adds to block */
 
 // Set at least one field to identifier of module record
 $module->setEntityIdentifier($field2);
 
 $field3 = new Vtiger_Field();
 $field3->name = 'assigned_user_id';
 $field3->label = 'Assigned To';
 $field3->table = 'vtiger_crmentity';
 $field3->column = 'smownerid';
 $field3->uitype = 53;
 $field3->typeofdata = 'V~M';
 $block1->addField($field3); /* Create the field and adds to block */
 
 $field4 = new Vtiger_Field();
 $field4->name = 'CreatedTime';
 $field4->label = 'Created Time';
 $field4->table = 'vtiger_crmentity';
 $field4->column = 'createdtime';
 $field4->uitype = 70;
 $field4->typeofdata = 'T~O';
 $field4->displaytype = 2;
 $block1->addField($field4); /* Create the field and adds to block */
 
 $field5 = new Vtiger_Field();
 $field5->name = 'ModifiedTime';
 $field5->label = 'Modified Time';
 $field5->table = 'vtiger_crmentity';
 $field5->column = 'modifiedtime';
 $field5->uitype = 70;
 $field5->typeofdata = 'T~O';
 $field5->displaytype = 2;
 $block1->addField($field5); /* Create the field and adds to block */
  
 $field6 = new Vtiger_Field();
 $field6->name = 'Breed';
 $field6->table = $module->basetable;
 $field6->column = 'breed';
 $field6->label = 'Breed';
 $field6->columntype = 'VARCHAR(100)';
 $field6->uitype = 15;
 $field6->typeofdata = 'V~O';
 $block1->addField($field6); /* Create the field and adds to block */

// Load initial values of pick list
 $field6->setPicklistValues( Array ('Poodle', 'Labrador', 'German Shepherd') );
  
 $field7 = new Vtiger_Field();
 $field7->name = 'Age';
 $field7->table = $module->basetable;
 $field7->column = 'age';
 $field7->label = 'Age';
 $field7->columntype = 'VARCHAR(100)';
 $field7->uitype = 15;
 $field7->typeofdata = 'V~O';
 $block1->addField($field7); /* Create the field and adds to block */

// Load initial values of pick list
 $field7->setPicklistValues( Array ('Under 1 yr.', '1 to 2 yrs.', '2 to 3 yrs') );
  
 $field8 = new Vtiger_Field();
 $field8->name = 'Gender';
 $field8->table = $module->basetable;
 $field8->column = 'gender';
 $field8->label = 'Gender';
 $field8->columntype = 'VARCHAR(100)';
 $field8->uitype = 15;
 $field8->typeofdata = 'V~O';
 $block1->addField($field8); /* Create the field and adds to block */

// Load initial values of pick list
 $field8->setPicklistValues( Array ('Female', 'Male') );
  
 $field9 = new Vtiger_Field();
 $field9->name = 'Aggression';
 $field9->table = $module->basetable;
 $field9->column = 'aggression';
 $field9->label = 'Aggression';
 $field9->uitype = 56;
 $field9->typeofdata = 'C~O';
 $block1->addField($field9); /* Create the field and adds to block */
  
 $field10 = new Vtiger_Field();
 $field10->name = 'HouseBroken';
 $field10->table = $module->basetable;
 $field10->column = 'house_broken';
 $field10->label = 'House Broken';
 $field10->uitype = 56;
 $field10->typeofdata = 'C~O';
 $block1->addField($field10); /* Create the field and adds to block */
  
 $field11 = new Vtiger_Field();
 $field11->name = 'TopProblem';
 $field11->table = $module->basetable;
 $field11->column = 'problem1';
 $field11->label = 'Top Problem';
 $field11->columntype = 'VARCHAR(100)';
 $field11->uitype = 15;
 $field11->typeofdata = 'V~O';
 $block1->addField($field11); /* Create the field and adds to block */

// Load initial values of pick list
 $field11->setPicklistValues( Array ('Socialization', 'Barking') );
  
 $field12 = new Vtiger_Field();
 $field12->name = '2ndProblem';
 $field12->table = $module->basetable;
 $field12->column = 'problem2';
 $field12->label = '2nd Problem';
 $field12->columntype = 'VARCHAR(100)';
 $field12->uitype = 15;
 $field12->typeofdata = 'V~O';
 $block1->addField($field12); /* Create the field and adds to block */

// Load initial values of pick list
 $field12->setPicklistValues( Array ('Socialization', 'Barking') );
  
 $field13 = new Vtiger_Field();
 $field13->name = '3rdProblem';
 $field13->table = $module->basetable;
 $field13->column = 'problem3';
 $field13->label = '3rd Problem';
 $field13->columntype = 'VARCHAR(100)';
 $field13->uitype = 15;
 $field13->typeofdata = 'V~O';
 $block1->addField($field13); /* Create the field and adds to block */

// Load initial values of pick list
 $field13->setPicklistValues( Array ('Socialization', 'Barking') );
/** END */

// Create default custom filter (mandatory)
$filter1 = new Vtiger_filter();
$filter1->name = 'All';
$filter1->isdefault = true;
$module->addFilter($filter1);

// Add fields to the filter created
$filter1->addField($field1)->addField($field6, 1)->addField($field7, 2);

// Create one more filter
$filter2 = new Vtiger_Filter();
$filter2->name = 'All2';
$module->addFilter($filter2);

// Add fields to the filter
$filter2->addField($field1);
$filter2->addField($field6, 1);

// Add rule to the filter field
$filter2->addRule($field1, 'CONTAINS', 'Test');

// Associate other modules to this module
$module->setRelatedList(Vtiger_Module::getInstance('Contacts'), 'Contacts', Array('ADD', 'SELECT'));

// Set sharing access o fthi smodule
$module->setDefaultSharing('Private');

// Enable and Disable available toold
$module->enableTools(Array('Import', 'Export'));
$module->disableTools('Merge');

?>

